"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var input = exports.input = "\n  class Point <T: number> {\n    x: T = 0;\n    y: T = 0;\n\n    constructor (x: T, y: T) {\n      this.x = x;\n      this.y = y;\n    }\n\n    static create (x: T, y: T): Point<T> {\n      return new Point(x, y);\n    }\n  }\n";

var expected = exports.expected = "\n  import t from \"flow-runtime\";\n\n  class Point {\n    @t.decorate(function () {\n      return this[t.TypeParametersSymbol].T;\n    })\n    x = 0;\n    @t.decorate(function () {\n      return this[t.TypeParametersSymbol].T;\n    })\n    y = 0;\n\n    constructor(x, y) {\n      this[t.TypeParametersSymbol] = {\n        T: t.typeParameter(\"T\", t.number())\n      };\n      let _xType = this[t.TypeParametersSymbol].T;\n      let _yType = this[t.TypeParametersSymbol].T;\n      t.param(\"x\", _xType).assert(x);\n      t.param(\"y\", _yType).assert(y);\n      this.x = x;\n      this.y = y;\n    }\n\n    static create(x, y) {\n      const _typeParameters = {\n        T: t.typeParameter(\"T\", t.number())\n      };\n      let _xType2 = _typeParameters.T;\n      let _yType2 = _typeParameters.T;\n      const _returnType = t.return(t.ref(Point, _typeParameters.T));\n      t.param(\"x\", _xType2).assert(x);\n      t.param(\"y\", _yType2).assert(y);\n      return _returnType.assert(new Point(x, y));\n    }\n  }\n";