"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var input = exports.input = "\n  class Point <T: number> {\n    x: T = 0;\n    y: T = 0;\n\n    constructor (x: T, y: T) {\n      this.x = x;\n      this.y = y;\n    }\n  }\n\n  type Float = number;\n  class FloatPoint extends Point<Float> {\n    constructor ([x, y]: [Float, Float]) {\n      super(x, y);\n    }\n  }\n\n  class FPoint<F: Float> extends Point<F> {\n    constructor ([x, y]: [F, F]) {\n      super(x, y);\n    }\n  }\n";

var expected = exports.expected = "\n  import t from \"flow-runtime\";\n\n  class Point {\n    @t.decorate(function () {\n      return this[t.TypeParametersSymbol].T;\n    })\n    x = 0;\n    @t.decorate(function () {\n      return this[t.TypeParametersSymbol].T;\n    })\n    y = 0;\n\n    constructor(x, y) {\n      this[t.TypeParametersSymbol] = {\n        T: t.typeParameter(\"T\", t.number())\n      };\n      let _xType = this[t.TypeParametersSymbol].T;\n      let _yType = this[t.TypeParametersSymbol].T;\n      t.param(\"x\", _xType).assert(x);\n      t.param(\"y\", _yType).assert(y);\n      this.x = x;\n      this.y = y;\n    }\n  }\n\n  const Float = t.type(\"Float\", t.number());\n  class FloatPoint extends Point {\n    constructor([x, y]) {\n      t.param(\"arguments[0]\", t.tuple(Float, Float)).assert(arguments[0]);\n      super(x, y);\n      t.bindTypeParameters(this, Float);\n    }\n  }\n\n  class FPoint extends Point {\n    constructor([x, y]) {\n      const _typeParameters3 = {\n        F: t.typeParameter(\"F\", Float)\n      };\n      t.param(\"arguments[0]\", t.tuple(_typeParameters3.F, _typeParameters3.F)).assert(arguments[0]);\n      super(x, y);\n      if (this[t.TypeParametersSymbol]) {\n        Object.assign(this[t.TypeParametersSymbol], _typeParameters3);\n      }\n      else {\n        this[t.TypeParametersSymbol] = _typeParameters3;\n      }\n      t.bindTypeParameters(this, this[t.TypeParametersSymbol].F);\n    }\n  }\n";