'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  return {
    visitor: {
      Program: function Program(path, _ref) {
        var opts = _ref.opts;

        var context = new _ConversionContext2.default();
        context.shouldAssert = opts.assert ? true : false;
        context.shouldDecorate = opts.decorate ? true : false;
        path.traverse((0, _firstPassVisitors2.default)(context));
        if (context.shouldImport) {
          (0, _attachImport2.default)(context, path);
        }
        path.traverse((0, _transformVisitors2.default)(context));
      }
    }
  };
};

var _ConversionContext = require('./ConversionContext');

var _ConversionContext2 = _interopRequireDefault(_ConversionContext);

var _attachImport = require('./attachImport');

var _attachImport2 = _interopRequireDefault(_attachImport);

var _firstPassVisitors = require('./firstPassVisitors');

var _firstPassVisitors2 = _interopRequireDefault(_firstPassVisitors);

var _transformVisitors = require('./transformVisitors');

var _transformVisitors2 = _interopRequireDefault(_transformVisitors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }