'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = transform;

var _babelTraverse = require('babel-traverse');

var _babelTraverse2 = _interopRequireDefault(_babelTraverse);

var _ConversionContext = require('./ConversionContext');

var _ConversionContext2 = _interopRequireDefault(_ConversionContext);

var _firstPassVisitors = require('./firstPassVisitors');

var _firstPassVisitors2 = _interopRequireDefault(_firstPassVisitors);

var _transformVisitors = require('./transformVisitors');

var _transformVisitors2 = _interopRequireDefault(_transformVisitors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function transform(input) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var context = new _ConversionContext2.default();
  context.shouldAssert = options.assert === 'undefined' ? process.env.NODE_ENV === 'development' : Boolean(options.assert);
  context.shouldDecorate = options.decorate === 'undefined' || context.shouldAssert ? true : Boolean(options.decorate);

  (0, _babelTraverse2.default)(input, (0, _firstPassVisitors2.default)(context));
  (0, _babelTraverse2.default)(input, (0, _transformVisitors2.default)(context));

  return input;
}